local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

hooksecurefunc("JumpOrAscendStart", function()
	if AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then 
		return
	elseif not AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then 
		if KKSettings.PlayerDancing == "YES" then
			StopMusic()
			KKSettings.PlayerDancing = 'NO'
		else
			return
		end
	end
end)

hooksecurefunc(WorldMapFrame, "OnMapChanged", function() 
	StopMusic()
	KKSettings.PlayerDancing = 'NO'
end);

function KickFrame_OnLoad()
	KickFrame:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	KickFrame:RegisterEvent("PLAYER_STARTED_MOVING")
	KickFrame:RegisterEvent("UNIT_AURA")
	
	SlashCmdList["DODANCE"] = dodance_command
	SLASH_DODANCE1 = "/dance"
	
	if KKSettings == "" or KKSettings == nil then
		KKSettings = {
			["PlayerDancing"] = 'NO'
		}
	end
end

function KickAFKCheck_OnLoad()
	KickAFKCheck:RegisterEvent("CHAT_MSG_SYSTEM")
end

function KickFrame_OnEvent(self, event, arg1)

local raceName, raceFile, raceID = UnitRace("player")
local gender = UnitSex("player")
local Map_Changed = false;

if event == "CHAT_MSG_TEXT_EMOTE" then
	if arg1 == L["You burst into dance."] then
		if raceID == 3 or raceID == 34 and gender == 2 or AuraUtil.FindAuraByName(L["Iron Boot Flask"], "player") then
			KKSettings.PlayerDancing = 'YES'
			PlayMusic("Interface\\AddOns\\KazotskyKick\\Music.mp3")
		end
	elseif (arg1:find("You dance with") ~= nil) then
		if raceID == 3 or raceID == 34 and gender == 2 or AuraUtil.FindAuraByName(L["Iron Boot Flask"], "player") then
			KKSettings.PlayerDancing = 'YES'
			PlayMusic("Interface\\AddOns\\KazotskyKick\\Music.mp3")
		end
	end
elseif event == "PLAYER_STARTED_MOVING" then
	if AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then 
		return
	elseif not AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then
		if KKSettings.PlayerDancing == "YES" then
			StopMusic()
			KKSettings.PlayerDancing = 'NO'
		else
			return
		end
	end
elseif event == "UNIT_AURA" then
	if AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then
		if raceID == 3 or raceID == 34 and gender == 2 then
			PlayMusic("Interface\\AddOns\\KazotskyKick\\Music.mp3")
		end
	elseif not AuraUtil.FindAuraByName(L["Iron Boot Flask"], "player") and not AuraUtil.FindAuraByName(L["Mesmerizing Fruit Hat"], "player") then
		if KKSettings.PlayerDancing == "YES" then
			return
		elseif KKSettings.PlayerDancing == "NO" then
			StopMusic()
			KKSettings.PlayerDancing = 'NO'
		end
	end
end

end

function KickAFKCheck_OnEvent(self, event, msg)
	if event == "CHAT_MSG_SYSTEM" then
		if (msg:find(L["You are now Away:"]) ~= nil) then
			StopMusic()
			KKSettings.PlayerDancing = 'NO'
		end
	end
end

function dodance()
	DoEmote("DANCE")
	KKSettings.PlayerDancing = 'YES'
	
	local raceName, raceFile, raceID = UnitRace("player")
	local gender = UnitSex("player")
	
	if raceID == 3 or raceID == 34 and gender == 2 or AuraUtil.FindAuraByName(L["Iron Boot Flask"], "player") then
		if GetLocale() == "zhCN" or GetLocale() == "zhTW" or GetLocale() == "koKR" or GetLocale() == "ruRU" then
			--Temporary fix that should (hopefully) let Chinese, Korean and Russian players hear the music.
			if raceID == 3 or raceID == 34 and gender == 2 or AuraUtil.FindAuraByName(L["Iron Boot Flask"], "player") then
				PlayMusic("Interface\\AddOns\\KazotskyKick\\Music.mp3")
			end
		end
	end
end